C---------------------------------------------------------------------
      PROGRAM POQUABE
C
C  PROGRAM 16
C 
C
C  THIS PROGRAM SOLVES TWO DIMENSIONAL (PO)TENTIAL PROBLEMS
C  USING (QUA)DRATIC (B)OUNDARY (E)LEMENTS.
C
      CHARACTER*10 FILEIN,FILEOUT
      COMMON/MATG/G(100,150)
      COMMON/MATH/H(100,100)
      COMMON N,L,INP,IPR
      DIMENSION X(101),Y(101)
      DIMENSION DFI(150),FI(100),KODE(150)
      DIMENSION CX(20),CY(20),SOL(20)
C
C  SET MAXIMUN DIMENSION OF THE SYSTEM OF EQUATIONS (NX)
C  NX= MAXIMUN NUMBER OF NODES= 2*MAXIMUN NUMBER OF ELEMENTS
C  NX1= 3*MAXIMUN NUMBER ELEMENTS
C
      NX=100
      NX1=150
C
C  ASSIGN NUMBERS FOR INPUT AND OUTPUT FILES
C
      INP=5
      IPR=6
C
C  READ NAMES AND OPEN  FILES FOR INPUT AND OUTPUT    
C
      WRITE(*,' (A) ') ' NAME OF INPUT FILE (MAX. 10 CHART.)'
      READ(*,'  (A) ')FILEIN
      OPEN(INP,FILE=FILEIN,STATUS='OLD')
      WRITE(*,' (A) ') ' NAME OF OUTPUT FILE (MAX. 10 CHART.)'
      READ(*,' (A) ')FILEOUT
      OPEN(IPR,FILE=FILEOUT,STATUS='NEW')
C 
C  READ DATA
C
      CALL INPUTPQ(CX,CY,X,Y,KODE,DFI)
C
C  COMPUTE H AND G MATRICES AND FORM SYSTEM (A X = F)
C
      CALL GHMATPQ(X,Y,G,H,FI,DFI,KODE,NX,NX1)
C
C  SOLVE SYSTEM OF EQUATIONS
C
      CALL SLNPD(H,FI,D,N,NX)
C
C  COMPUTE POTENTIAL VALUES AT INTERNAL POINTS
C
      CALL INTERPQ(FI,DFI,KODE,CX,CY,X,Y,SOL)
C
C  PRINT RESULTS AT BOUNDARY NODES AND INTERNAL POINTS
C
      CALL OUTPTPQ(X,Y,FI,DFI,CX,CY,SOL)
C
C   CLOSE INPUT AND OUTPUT FILES
C
      CLOSE (INP)
      CLOSE (IPR)
      STOP
      END
C-----------------------------------------------------------------------
      SUBROUTINE INPUTPQ(CX,CY,X,Y,KODE,DFI)
C
C  PROGRAM 17
C
C  NE= NUMBER OF BOUNDARY ELEMENTS
C  N = NUMBER OF BOUNDARY NODES = 2 * NE
C  L = NUMBER OF INTERNAL POINTS
C 
      CHARACTER*80 TITLE
      COMMON N,L,INP,IPR
      DIMENSION KODE(150),X(101),Y(101),CX(20),CY(20),DFI(150)
      WRITE(IPR,100)
  100 FORMAT(' ',79('*'))
C
C  READ JOB TITLE
C
      READ(INP,'(A)') TITLE
      WRITE(IPR,'(A)') TITLE
C
C  READ NUMBER OF BOUNDARY ELEMENTS AND INTERNAL POINTS
C
      READ(INP,*)NE,L
      WRITE(IPR,210)NE,L
  210 FORMAT(//2X,'DATA'/2X,'NUMBER OF BOUNDARY ELEMENTS=',
     1I3/2X,'NUMBER OF INTERNAL POINTS=',I3)
      N=2*NE
C
C  READ BOUNDARY NODES COORDINATES IN ARRAYS X AND Y    
C
      WRITE(IPR,500)
      READ(INP,*) (X(I),Y(I),I=1,N)
      DO 10 I=1,N
   10 WRITE(IPR,240) I,X(I),Y(I)
  500 FORMAT(//2X,'BOUNDARY NODES COORDINATES'///4X,
     1'NODE',10X,'X',18X,'Y'/)
  240 FORMAT(5X,I3,2(5X,E14.7))
C
C  READ BOUNDARY CONDITIONS IN DFI(I) VECTOR,IF KODE(I)=0
C  THE DFI(I) VALUE IS A KNOWN POTENTIAL; IF KODE(I)=1 THE
C  DFI(I) VALUE IS A KNOWN POTENTIAL DERIVATIVE (FLUX).
C  THREE BOUNDARY CONDITIONS ARE READ PER ELEMENT.
C  NODES BETWEEN TWO ELEMENTS MAY HAVE TWO DIFFERENT VALUES
C  OF THE POTENTIAL DERIVATIVE BUT ONLY ONE VALUE OF THE 
C  POTENTIAL.
C
      WRITE(IPR,800)
  800 FORMAT(//2X,'BOUNDARY CONDITIONS'//11X,
     1'-----FIRST NODE------',3X,'-----SECOND NODE-----',3X,
     2'-----THIRD NODE------'/13X,'PRESCRIBED',14X,
     3'PRESCRIBED',14X,'PRESCRIBED'/1X,'ELEMENT',8X,'VALUE',
     47X,'CODE',8X,'VALUE',7X,'CODE',8X,'VALUE',7X,'CODE')
      DO 20 I=1,NE
      READ(INP,*) (KODE(3*I-3+J),DFI(3*I-3+J),J=1,3)
   20 WRITE(IPR,950)I,(DFI(3*I-3+J),KODE(3*I-3+J),J=1,3)
  950 FORMAT(3X,I3,2X,3(4X,E14.7,5X,I1))               
C
C  READ COORDINATES OF THE INTERNAL POINTS
C
      IF(L.EQ.0) GO TO 30
      READ(INP,*) (CX(I),CY(I),I=1,L)
   30 RETURN
      END
C------------------------------------------------------------------------
      SUBROUTINE GHMATPQ(X,Y,G,H,FI,DFI,KODE,NX,NX1)
C
C  PROGRAM 18
C
C  THIS SUBROUTINE COMPUTES THE G AND H MATRICES AND FORMS
C  THE SYSTEM OF EQUATIONS A X = F 
C  H IS A SQUARE MATRIX (2*NE,2*NE); G IS RECTANGULAR (2*NE,3*NE)
C
      DIMENSION X(101),Y(101),G(NX,NX1),H(NX,NX),HW(3),GW(3)
      DIMENSION FI(100),DFI(150),KODE(150)
      COMMON N,L,INP,IPR   
      NE=N/2
      DO 20 I=1,N
      DO 11 J=1,N
   11 H(I,J)=0.
      DO 12 J=1,3*NE
   12 G(I,J)=0.
   20 CONTINUE
      X(N+1)=X(1)
      Y(N+1)=Y(1)
C
C  COMPUTE THE GW AND HW MATRICES FOR EACH COLLOCATION 
C  POINT AND EACH BOUNDARY ELEMENT
C
      DO 40 LL=1,N
      DO 40 I=1,N-1,2
      IF((LL-I)*(LL-I-1)*(LL-I-2)*(LL-I+N-2)) 22,21,22
   21 NODO=LL-I+1
      IF((LL.EQ.1).AND.(I.EQ.N-1)) NODO=NODO+N
      CALL EXTINPQ(X(LL),Y(LL),X(I),Y(I),X(I+1),Y(I+1),X(I+2),Y(I+2)
     *,HW,GW)
      CALL LOCINPQ(X(I),Y(I),X(I+1),Y(I+1),X(I+2),Y(I+2),GW,NODO)
      GO TO 34
   22 CALL EXTINPQ(X(LL),Y(LL),X(I),Y(I),X(I+1),Y(I+1),X(I+2),Y(I+2)
     *,HW,GW)
C
C  PLUG THE GW AND HW MATRICES INTO THE GENERAL G AND H MATRICES.
C
   34 DO 38 J=1,3
      K=3*(I-1)/2
      G(LL,K+J)=G(LL,K+J)+GW(J)
      IF(I-N+1) 37,35,37
   35 IF(J-3) 37,36,36
   36 H(LL,1)=H(LL,1)+HW(J)      
      GO TO 38
   37 H(LL,I-1+J)=H(LL,I-1+J)+HW(J)
   38 CONTINUE
   40 CONTINUE
C
C  COMPUTE THE DIAGONAL COEFFICIENTS OF THE H MATRIX 
C
      DO 70 I=1,N
      H(I,I)=0.
      DO 60 J=1,N
      IF(I.EQ.J) GO TO 60
      H(I,I)=H(I,I)-H(I,J)
   60 CONTINUE
C
C  ADD ONE TO THE DIAGONAL COEFFICIENTS FOR
C  EXTERNAL PROBLEMS.
C
      IF(H(I,I)) 65,70,70
   65 H(I,I)=1.+H(I,I)
   70 CONTINUE
C
C  REORDER THE COLUMNS OF THE SYSTEM OF EQUATIONS IN ACCORDANCE
C  WITH THE BOUNDARY CONDITIONS AND FORM SYSTEM MATRIX A WHICH
C  IS STORED IN H
C
      DO 180 I=1,NE
      DO 170 J=1,3
      IF(KODE(3*I-3+J)) 110,110,170
  110 IF((I-NE).NE.0 .OR. J.NE.3) GO TO 125
      IF(KODE(1)) 115,115,113
  113 DO 114 K=1,N
      CH=H(K,1)
      H(K,1)=-G(K,3*I)
  114 G(K,3*I)=-CH
      GO TO 170
  115 DO 116 K=1,N
      H(K,1)=H(K,1)-G(K,3*I)
  116 G(K,3*I)=0.
      GO TO 170
  125 IF(I.EQ.1 .OR. J.GT.1 .OR. KODE(3*I-3).EQ.1) GO TO 130       
      DO 129 K=1,N
      H(K,2*I-1)=H(K,2*I-1)-G(K,3*I-2)
  129 G(K,3*I-2)=0.
      GO TO 170
  130 DO 132 K=1,N
      CH=H(K,2*I-2+J)
      H(K,2*I-2+J)=-G(K,3*I-3+J)
  132 G(K,3*I-3+J)=-CH
  170 CONTINUE
  180 CONTINUE
C
C  FORM THE RIGHT HAND SIDE VECTOR F WHICH IS STORED IN FI
C
      DO 190 I=1,N
      FI(I)= 0.
      DO 185 J=1,3*NE
  185 FI(I)=FI(I)+G(I,J)*DFI(J)
  190 CONTINUE
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE EXTINPQ(XP,YP,X1,Y1,X2,Y2,X3,Y3,HW,GW)
C
C  PROGRAM 19
C
C  THIS SUBRUOTINE COMPUTES THE  HW AND GW MATRICES
C  THAT RELATE A NODE (XP,YP) WITH A BOUNDARY
C  ELEMENT USING GAUSS QUADRATURE
C
C  RA           = RADIUS 
C  RD1,RD2,RDN  = RADIUS DERIVATIVES
C  ETA1,ETA2    = COMPONENTS OF THE UNIT NORMAL TO THE ELEMENT
C  XCO,YCO      = INTEGRATION POINT ALONG THE ELEMENT
C  XJA          = JACOBIAN
C
      COMMON N,L,INP,IPR 
      DIMENSION GW(3),HW(3)
      DIMENSION GI(10),OME(10)
      DATA GI/0.9739065285,-0.9739065285,0.8650633666,-0.8650633666
     @,0.6794095683,-0.6794095682,0.4333953941,-0.4333953941,
     @0.1488743389,-0.1488743389/                                    
      DATA OME/0.0666713443,0.0666713443,0.1494513491,0.1494513491
     @,0.2190863625,0.2190863625,0.2692667193,0.2692667193,
     @0.2955242247,0.2955242247/
      DO 20 J=1,3
      HW(J)=0.
   20 GW(J)=0.
      A=X3-2*X2+X1
      B=(X3-X1)/2
      C=Y3-2*Y2+Y1
      D=(Y3-Y1)/2 
      DO 40 I=1,10
C
C  COMPUTE THE VALUES OF THE SHAPE FUNCTIONS AT THE
C  INTEGRATION POINTS
C 
      F1=GI(I)*(GI(I)-1)*0.5
      F2=1.-GI(I)**2
      F3=GI(I)*(GI(I)+1)*0.5
C
C  COMPUTE GEOMETRICAL PROPERTIES AT THE INTEGRATION POINTS
C 
      XCO=X1*F1+X2*F2+X3*F3
      YCO=Y1*F1+Y2*F2+Y3*F3
      XJA=SQRT((GI(I)*A+B)**2+(GI(I)*C+D)**2)
      ETA1=(GI(I)*C+D)/XJA
      ETA2=-(GI(I)*A+B)/XJA
      RA=SQRT((XP-XCO)**2+(YP-YCO)**2)
      RD1=(XCO-XP)/RA
      RD2=(YCO-YP)/RA
      RDN=RD1*ETA1+RD2*ETA2
C
C  COMPUTE GW AND HW MATRICES
C
      GW(1)=GW(1)+ALOG(1./RA)*OME(I)*XJA*F1
      GW(2)=GW(2)+ALOG(1./RA)*OME(I)*XJA*F2
      GW(3)=GW(3)+ALOG(1./RA)*OME(I)*XJA*F3
      HW(1)=HW(1)-RDN/RA*OME(I)*XJA*F1
      HW(2)=HW(2)-RDN/RA*OME(I)*XJA*F2
40    HW(3)=HW(3)-RDN/RA*OME(I)*XJA*F3
      RETURN                                                            
      END 
C-----------------------------------------------------------------------
      SUBROUTINE LOCINPQ(XG1,YG1,XG2,YG2,XG3,YG3,GW,NODO)
C
C  PROGRAM 20
C
C  THIS SUBROUTINE COMPUTES THE GW MATRIX WHEN THE COLLOCATION
C  POINT IS ONE OF THE NODES OF THE INTEGRATION ELEMENT.
C  THE COEFFICIENTS ARE COMPUTED BY NUMERICAL INTEGRATION:
C  THE NON SINGULAR PART IS COMPUTED USING STANDARD GAUSS QUADRATURE,
C  THE LOGARITHMIC PART IS COMPUTED USING A SPECIAL QUADRATURE FORMULA.
C
      COMMON N,L,INP,IPR
      DIMENSION GI(10),OME(10),GIL(10),OMEL(10),GW(3)
C
C  DATA FOR THE GAUSS QUADRATURE
C
      DATA GI/0.9739065285,-0.9739065285,0.8650633666,-0.8650633666      
     @,0.6794095682,-0.6794095682,0.4333953941,-0.4333953941,
     @0.1488743389,-0.1488743389/ 
      DATA OME/0.0666713443,0.0666713443,0.1494513491,0.1494513491 
     @,0.2190863625,0.2190863625,0.2692667193,0.2692667193,
     @0.2955242247,0.2955242247/
C
C  DATA FOR THE SPECIAL QUADRATURE
C
      DATA GIL/0.0090426309,0.0539712662,0.1353118246,0.2470524162
     @,0.3802125396,0.5237923179,0.6657752055,0.7941904160,    
     @0.8981610912,0.9688479887/
      DATA OMEL/0.1209551319,0.1863635425,0.1956608732,0.1735771421
     @,0.1356956729,0.0936467585,0.0557877273,0.0271598109,
     @0.0095151826,0.0016381576/
C
C  SET A LOCAL COORDINATES SYSTEM
C
      GO TO(1,2,3),NODO
    1 X3=XG3-XG1
      Y3=YG3-YG1
      X2=XG2-XG1
      Y2=YG2-YG1
      A1=(X3-2*X2)*0.5
      B1=X2 
      A2=(Y3-2*Y2)*0.5
      B2=Y2 
      GO TO 4 
    2 X3=XG3-XG2
      Y3=YG3-YG2
      X1=XG1-XG2
      Y1=YG1-YG2
      A1=X1+X3
      B1=X3-X1
      A2=Y1+Y3
      B2=Y3-Y1
      GO TO 4 
    3 X2=XG2-XG3
      Y2=YG2-YG3
      X1=XG1-XG3
      Y1=YG1-YG3
      A1=(X1-2*X2)*0.5
      B1=-X2
      A2=(Y1-2*Y2)*0.5
      B2=-Y2
    4 CONTINUE    
C
      DO 10 J=1,3
   10 GW(J)=0.
C
      DO 250 I=1,10
C
C  COMPUTE SHAPE FUNCTIONS FOR NUMERICAL INTEGRATIONS
C
      F3=0.5*GI(I)*(GI(I)+1.)
      F2=1.-GI(I)**2
      F1=0.5*GI(I)*(GI(I)-1.)
      FL3=GIL(I)*(2.*GIL(I)-1.)
      FL2=4.*GIL(I)*(1.-GIL(I))
      FL1=(GIL(I)-1.)*(2.*GIL(I)-1.)
      FLN3=0.5*GIL(I)*(GIL(I)+1.)
      FLN2=1.-GIL(I)**2
      FLN1=0.5*GIL(I)*(GIL(I)-1.)
C
C  COMPUTE GEOMETRICAL PROPERTIES
C
      GO TO(50,60,70) NODO
C
   50 XJA1=SQRT((4*A1*GIL(I)-2*A1+0.5*X3)**2+(4*A2*GIL(I)-2*A2+0.5*Y3)** 
     @  2)*2 
      XJA2=SQRT((A1*GI(I)*2+0.5*X3)**2+(A2*GI(I)*2+0.5*Y3)**2)
      XLO=-ALOG(2*SQRT((GI(I)*A1+B1)**2+(GI(I)*A2+B2)**2))
      S3=FL3*XJA1*OMEL(I)+F3*XJA2*XLO*OME(I) 
      S2=FL2*XJA1*OMEL(I)+F2*XJA2*XLO*OME(I) 
      S1=FL1*XJA1*OMEL(I)+F1*XJA2*XLO*OME(I) 
      GO TO 200 
   60 XJA1=SQRT((0.5*B1-A1*GIL(I))**2+(0.5*B2-A2*GIL(I))**2)
      XJA11=SQRT((0.5*B1+A1*GIL(I))**2+(0.5*B2+A2*GIL(I))**2)
      XJA2=SQRT((0.5*B1+A1*GI(I))**2+(0.5*B2+A2*GI(I))**2)
      XLO=-0.5*ALOG((GI(I)*A1*0.5+B1*0.5)**2+(GI(I)*A2*0.5+B2*0.5)**2) 
      S3=(FLN1*XJA1+FLN3*XJA11)*OMEL(I)+F3*XJA2*XLO*OME(I) 
      S2=FLN2*(XJA1+XJA11)*OMEL(I)+F2*XJA2*XLO*OME(I)
      S1=(FLN3*XJA1+FLN1*XJA11)*OMEL(I)+F1*XJA2*XLO*OME(I)
      GO TO 200 
   70 XJA1=SQRT((2*A1-4*A1*GIL(I)-0.5*X1)**2+(2*A2-4*A2*GIL(I)-0.5*Y1)** 
     @2)*2
      XJA2=SQRT((2*A1*GI(I)-0.5*X1)**2+(2*A2*GI(I)-0.5*Y1)**2)
      XLO=-ALOG(2*SQRT((A1*GI(I)+B1)**2+(A2*GI(I)+B2)**2)) 
      S3=FL1*XJA1*OMEL(I)+F3*XJA2*XLO*OME(I)     
      S2=FL2*XJA1*OMEL(I)+F2*XJA2*XLO*OME(I) 
      S1=FL3*XJA1*OMEL(I)+F1*XJA2*XLO*OME(I) 
C
C  COMPUTE GW MATRIX
C
  200 GW(3)= GW(3)+S3 
      GW(2)= GW(2)+S2 
      GW(1)= GW(1)+S1 
C
  250 CONTINUE
C
      RETURN
      END 
C------------------------------------------------------------------------
      SUBROUTINE SLNPD(A,B,D,N,NX)
C
C  PROGRAM 6
C 
C SOLUTION OF LINEAR SYSTEMS OF EQUATIONS 
C BY THE GAUSS ELIMINATION METHOD PROVIDING 
C FOR INTERCHANGING ROWS WHEN ENCOUNTERING A
C ZERO DIAGONAL COEFICIENT
C 
C A : SYSTEM MATRIX 
C B : ORIGINALLY IT CONTAINS THE INDEPENDENT
C     COEFFICIENTS. AFTER SOLUTION IT CONTAINS
C     THE VALUES OF THE SYSTEM UNKNOWNS.
C 
C N : ACTUAL NUMBER OF UNKNOWNS 
C NX: ROW AND COLUMN DIMENSION OF A 
C 
      DIMENSION B(NX),A(NX,NX)
C
      TOL=1.E-6
C
      N1=N-1
      DO 100 K=1,N1 
      K1=K+1
      C=A(K,K)
      IF(ABS(C)-TOL)1,1,3
    1 DO 7 J=K1,N 
C 
C TRY TO INTERCHANGE ROWS TO GET NON ZERO DIAGONAL COEFFICIENT
C 
      IF(ABS((A(J,K)))-TOL)7,7,5 
    5 DO 6 L=K,N
      C=A(K,L)
      A(K,L)=A(J,L) 
    6 A(J,L)=C
      C=B(K)
      B(K)=B(J) 
      B(J)=C
      C=A(K,K)
      GO TO 3 
    7 CONTINUE
      GO TO 8
C 
C DIVIDE ROW BY DIAGONAL COEFFICIENT
C 
    3 C=A(K,K)
      DO 4 J=K1,N 
    4 A(K,J)=A(K,J)/C 
      B(K)=B(K)/C 
C 
C ELIMINATE UNKNOWN X(K) FROM ROW I 
C 
      DO 10 I=K1,N
      C=A(I,K)
      DO 9 J=K1,N 
    9 A(I,J)=A(I,J)-C*A(K,J)
   10 B(I)=B(I)-C*B(K)
  100 CONTINUE
C 
C COMPUTE LAST UNKNOWN
C 
      IF(ABS((A(N,N)))-TOL)8,8,101 
  101 B(N)=B(N)/A(N,N)
C 
C APPLY BACKSUBSTITUTION PROCESS TO COMPUTE REMAINING UNKNOWNS
C 
      DO 200 L=1,N1 
      K=N-L 
      K1=K+1
      DO 200 J=K1,N 
  200 B(K)=B(K)-A(K,J)*B(J) 
C 
C COMPUTE VALUE OF DETERMINANT
C 
      D=1.
      DO 250 I=1,N
  250 D=D*A(I,I)
      GO TO 300
    8 WRITE(IPR,2) K
    2 FORMAT(' **** SINGULARITY IN ROW',I5) 
      D=0.
  300 RETURN
      END 
C-----------------------------------------------------------------------  
      SUBROUTINE INTERPQ(FI,DFI,KODE,CX,CY,X,Y,SOL)
C
C  PROGRAM 21
C
C  THIS SUBROUTINE COMPUTES THE VALUES OF POTENTIAL AT
C  INTERNAL POINTS.
C
      COMMON N,L,INP,IPR
      DIMENSION FI(100),DFI(150),KODE(150),CX(20),CY(20)
      DIMENSION X(101),Y(101),SOL(20)
      DIMENSION HW(3),GW(3)
C
C  REARRANGE THE FI AND DFI ARRAYS TO STORE ALL THE VALUES OF THE
C  POTENTIAL IN FI AND ALL THE VALUES OF THE DERIVATIVE IN DFI
C
      NE=N/2
      DO 180 I=1,NE
      DO 170 J=1,3
      IF(KODE(3*I-3+J)) 110,110,170
  110 IF((I-NE).NE.0 .OR. J.NE.3) GO TO 125
      IF(KODE(1)) 114,114,113
  113 CH=FI(1)
      FI(1)=DFI(3*I)
      DFI(3*I)=CH
      GO TO 170
  114 DFI(3*I)=DFI(1)
      GO TO 170
  125 IF(I.EQ.1 .OR. J.GT.1 .OR. KODE(3*I-3).EQ.1) GO TO 130
      DFI(3*I-2)=DFI(3*I-3)
      GO TO 170
  130 CH=FI(2*I-2+J)
      FI(2*I-2+J)=DFI(3*I-3+J)
      DFI(3*I-3+J)=CH
  170 CONTINUE
  180 CONTINUE
C
C  COMPUTE THE VALUES OF POTENTIAL AT INTERNAL POINTS
C
      IF(L.EQ.0) GO TO 50
      DO 240 K=1,L
      SOL(K)=0.
      DO 230 I=1,NE
      CALL EXTINPQ(CX(K),CY(K),X(2*I-1),Y(2*I-1),X(2*I),Y(2*I),X(2*I+1)
     1,Y(2*I+1),HW,GW)
      DO 220 J=1,3
      IJ2=2*I-2+J
      IF(IJ2.GT.(2*NE)) IJ2=J-2
  220 SOL(K)=SOL(K)+GW(J)*DFI(3*I-3+J)-HW(J)*FI(IJ2)
  230 CONTINUE
      SOL(K)=SOL(K)/(2.*3.1415926536)
  240 CONTINUE
   50 RETURN
      END
C------------------------------------------------------------------------
      SUBROUTINE OUTPTPQ(X,Y,FI,DFI,CX,CY,SOL)
C
C  PROGRAM 22
C
C  THIS SUBROUTINE PRINTS THE VALUES OF THE POTENTIAL AND ITS NORMAL
C  DERIVATIVE AT BOUNDARY NODES. IT ALSO PRINTS THE VALUES OF THE 
C  POTENTIAL AT INTERNAL POINTS
C
      COMMON N,L,INP,IPR
      DIMENSION X(101),Y(101),FI(100),DFI(150),CX(20),CY(20),SOL(20) 
C
      NE=N/2
      WRITE(IPR,100)
  100 FORMAT(' ',79('*')//2X,'RESULTS'//2X,'BOUNDARY NODES'//
     156X,'POTENTIAL DERIVATIVE'/
     29X,'X',15X,'Y',12X,'POTENTIAL',6X,'BEFORE NODE',6X,'AFTER NODE'/)
      WRITE(IPR,200) X(1),Y(1),FI(1),DFI(3*NE),DFI(1)
      WRITE(IPR,200) X(2),Y(2),FI(2),DFI(2),DFI(2)
      DO 10 I=2,NE 
      WRITE(IPR,200) X(2*I-1),Y(2*I-1),FI(2*I-1),DFI(3*I-3),DFI(3*I-2) 
   10 WRITE(IPR,200) X(2*I),Y(2*I),FI(2*I),DFI(3*I-1),DFI(3*I-1) 
  200 FORMAT(5(2X,E14.5))
C
      IF(L.EQ.0) GO TO 30
      WRITE(IPR,300)
  300 FORMAT(//,2X,'INTERNAL POINTS',//9X,'X',15X,'Y',12X,'POTENTIAL',/)
      DO 20 K=1,L 
   20 WRITE(IPR,400)CX(K),CY(K),SOL(K)
  400 FORMAT(3(2X,E14.5)) 
   30 WRITE(IPR,500)
  500 FORMAT(' ',79('*'))
      RETURN
      END
C-----------------------------------------------------------------------
